#pragma once

using namespace System::Windows;

#ifdef __cplusplus
extern "C" {
#endif

	
ref class FilterPropertyFrom : public System::Windows::Forms::Form
{

public:
	FilterPropertyFrom(IDirectJoyHack *pVFT);

private:
	void InitializeComponent();

	void testtt(System::Object ^sender, Forms::KeyEventArgs ^e);

	void button_file_Click(System::Object ^sender, System::EventArgs ^e);
	void button_reload_Click(System::Object ^sender, System::EventArgs ^e);
	void controls_Change(System::Object ^sender, System::EventArgs ^e);
	
	void get_Settings();
	void put_Settings();

	IDirectJoyHack *m_pDirectJoyHack;

	Forms::Button ^button_reload;
	Forms::Button ^button_file;
	Forms::CheckBox ^check_hidesub;
	Forms::CheckBox ^check_immediate;
	Forms::CheckBox ^check_debugout;
	Forms::Label ^label_predelay;
	Forms::Label ^label_sufdelay;
	Forms::NumericUpDown ^num_delay;
	Forms::TextBox ^text_filename;
};

class CDirectJoyHackProperties : public CBasePropertyPage
{

public:

    static CUnknown * WINAPI CreateInstance(LPUNKNOWN lpunk, HRESULT *phr);

    HRESULT OnConnect(IUnknown * punk);
    HRESULT OnDisconnect(void);
    HRESULT OnDeactivate(void);

    CDirectJoyHackProperties(LPUNKNOWN lpunk, HRESULT *phr);

private:
	INT_PTR OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	HWND		m_hwnd;
	IDirectJoyHack *m_pDirectJoyHack;
	gcroot< FilterPropertyFrom^ > form;

};


#ifdef __cplusplus
}
#endif
