#pragma once

#ifdef __cplusplus
extern "C" {
#endif

// {EA32143B-AED5-451e-BB72-5D77F7DEBD37}
DEFINE_GUID(IID_IDirectJoyHack, 
0xea32143b, 0xaed5, 0x451e, 0xbb, 0x72, 0x5d, 0x77, 0xf7, 0xde, 0xbd, 0x37);


DECLARE_INTERFACE_(IDirectJoyHack, IUnknown) {
	
	    STDMETHOD(get_FileName) (THIS_
                    WCHAR* fn	// fn should point to a buffer allocated to at least the length of MAX_PATH (=260)
                 ) PURE;

        STDMETHOD(put_FileName) (THIS_
                    WCHAR* fn
                 ) PURE;

        STDMETHOD(reload_File) (THIS_
                 ) PURE;

		STDMETHOD(get_ChangeImmediate) (THIS_
                    bool* fImmediate
                 ) PURE;

        STDMETHOD(put_ChangeImmediate) (THIS_
                    bool fImmediate
                 ) PURE;

        STDMETHOD(get_HideSubtitles) (THIS_
                    bool* fHideSubtitles
                 ) PURE;

        STDMETHOD(put_HideSubtitles) (THIS_
                    bool fHideSubtitles
                 ) PURE;

		STDMETHOD(get_Delay) (THIS_
                    __int32* fDelay //frame
                 ) PURE;

        STDMETHOD(put_Delay) (THIS_
                    __int32 fDelay
                 ) PURE;

        STDMETHOD(get_DebugOutput) (THIS_
                    bool* fDebugOut
                 ) PURE;

        STDMETHOD(put_DebugOutput) (THIS_
                    bool fDebugOut
                 ) PURE;

};


#ifdef __cplusplus
}
#endif
